/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * Attacker.java
 *
 * $Id: Attacker.java,v 1.9 2003/10/02 02:20:43 visigoth_6 Exp $
 *
 */

package com.securitycentric.metacoretex;

import com.securitycentric.metacoretex.lib.*;
import com.securitycentric.metacoretex.interfaces.*;

import java.util.*;
import javax.swing.JProgressBar;

/**
 *
 * @author  visigoth
 */
public class Attacker extends java.lang.Thread {
    
    public Attacker(ThreadGroup group) {
        super(group, "AttackerThread");
        pThGroup = new ThreadGroup("probeThreads");
        total = Init.allProbeVect.size();
        // Can't be deviding by 0 now can we?
        if (total == 0)
            total = 1;
    }
    
    public void run() {
        
        curTarg = TLock.lockTarget();
        
        while (curTarg != null && run == true) {
            
            progress = 0;
            
            yield();
            
            attack();
            
            //Done with this target, get next or null
            curTarg = TLock.lockTarget();
        }

        newp = null;
        // Got null, we're done.  Are we last?
        int count = Thread.activeCount();
        //System.out.println("Found " + String.valueOf(count) + " Threads");
        if (count <= 1)
            Init.scanDone();
    }
    
    /*
     * This is the attack loop
     */
    private void attack() {
        
        Iterator i = Init.allProbeVect.iterator();
        long start, stop;
        
        // Add the target to the report vect right away so if we die...
        Init.reportVect.add(curTarg);
        
        while (i.hasNext() && run == true) {
            Probe p = (Probe) i.next();
            
            progress++;
            Init.fireStatusChanged();
            
            // Don't run if we aren't enabled ;)
            // Need more don't run logic for safe etc.
            if (!p.isEnabled())
                continue;
            
            try {
                
                newp = (Probe)p.getClass().newInstance();
                newp.replaceOptions(p.dumpOptions());
                
                if (Init.safeChecks && (! newp.hasSafe()))
                    continue;
                
                newp.setTarget(curTarg);
                
                int timeout = Init.probeTimeout*1000;
                
                /* If the probe timeout is set to the default
                 * lets set it to our global config
                 */
                if (newp.getTimeout() == 42666) {
                    newp.setTimeout(timeout);
                }
                
                pTh = new Thread(pThGroup, newp);
                start = new Date().getTime();
                pTh.start();
                pTh.join(newp.getTimeout());
                stop = new Date().getTime();
                if(pTh.isAlive()) {
                    // Better way?
                    pTh.stop();
                    curTarg.exVect.add(new ProbeException(newp.getName() + " Timed Out!"));
                }
                
                if (newp.isReportable()) {
                    ProbeReport rep = new ProbeReport(newp.getProbeId(),newp.getReport());
                    
                    // Set info in the probe report
                    rep.setProbeName(newp.getName());
                    rep.setSeverity(newp.getSeverity());
                    rep.setProbeVersion(newp.getVersion());
                    rep.setStart(start);
                    rep.setStop(stop);
                    rep.setProbeOptions(newp.dumpOptions());
                    
                    curTarg.addProbeReport(rep);
                }
                
                ProbeException pe = newp.getException();
                if (pe != null) {
                    pe.setProbeName(newp.getName());
                    pe.setProbeOptions(newp.dumpOptions());
                    curTarg.exVect.add(pe);
                }
                
            } catch (InterruptedException ie) {
                pTh.stop();
                run = false;
                Init.fireStatusChanged();
                continue;
            } catch (InstantiationException ce) {
                System.err.println("Thread failed to instantiate class");
                continue;
            } catch (IllegalAccessException ie) {
                System.err.println("Thread failed to instantiate class");
                continue;
            }
        }
    }
    
    public Target getCurTarg() {
        return(curTarg);
    }
    
    public String getTargName() {
        if (curTarg == null)
            return("None");
        
        return(curTarg.getHost());
    }
    
    public Integer getProgress() {
        return(new Integer(progress));
    }
    
    public String getProbeName() {
        if (newp == null)
            return("Completed");
        
        return(newp.getName());
    }
    
    Target curTarg;
    Probe newp = null;
    Thread pTh;
    ThreadGroup pThGroup;
    public boolean run = true;
    int progress, total;
}
