/*
 * Updater.java
 *
 * Created on September 22, 2003, 12:25 PM
 *
 * $Id: Updater.java,v 1.3 2003/10/01 14:26:30 visigoth_6 Exp $
 */

package com.securitycentric.metacoretex;

import com.securitycentric.metacoretex.lib.*;
import com.securitycentric.metacoretex.xml.update.*;
import com.securitycentric.metacoretex.gui.*;

/**
 *
 * @author  visigoth
 */
public class Updater extends java.lang.Thread {
    
    
    
    /** Creates a new instance of Updater */
    public Updater() {
        super();
        updateType = UPDATE_ALL;
    }
    
    public Updater(int type) {
        super();
        updateType = type;
    }
    
    public void run() {
        int fileCount = 0;
        MCTXUpdate upDate;
        
        updateStatus("Getting Update XML", 20);
        
        try {
            upDate = UpdateToolz.getUpdate();
        } catch (UpdateException e) {
            Init.doError("Update Error while getting update XML", e);
	    closeStatus();
            return;
        }
        
        updateStatus("Processing Local Options", 30);
        
        switch (updateType) {
            case UPDATE_PROBES:
                UpdateToolz.onlyProbes(upDate);
                break;
                
            case UPDATE_CONFIG:
                UpdateToolz.onlyConfigFiles(upDate);
                break;
                
            case UPDATE_JARS:
                UpdateToolz.onlyJars(upDate);
                break;
                
            case UPDATE_ALL:
                break;
                
            default:
                Init.doError("Updater Error", new Exception("Unknown Update Type"));
	        closeStatus();
                return;
        }
        
        updateStatus("Processing Current Versions", 50);
        UpdateToolz.removeDuplicates(upDate);
        
        updateStatus("Getting Update Files", 80);
        try {
            fileCount = UpdateToolz.doUpdate(upDate);
        } catch (UpdateException e) {
            Init.doError("Updater Error",e);
	    closeStatus();
            return;
        }
        
        updateStatus("Complete",100);
        
        Init.doMessage("Update Complete","Update is complete. "+
                  fileCount+" files updated.\n"+
                  "If any updated files were JARs (not probes),\n"+
                  "you should probably restart Metacoretex");

	closeStatus();
        
    }

    private void closeStatus() {
        if (upStat != null) {
            upStat.setVisible(false);
            upStat.dispose();
        }
    }
    
    private void updateStatus(String mess, int complete) {
        if ( Init.console ) {
            System.out.println(mess);
        } else {
            if (upStat == null) {
                upStat = new UpdateStatus();
                Init.centerWindow(upStat);
                upStat.show();
            }
            upStat.update(mess, complete);
        }
    }
    
    private int updateType = 0;
    private UpdateStatus upStat = null;
    
    public static final int UPDATE_PROBES = 1;
    public static final int UPDATE_CONFIG = 2;
    public static final int UPDATE_JARS = 3;
    public static final int UPDATE_ALL = 4;
}
