/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * AboutProbeTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.interfaces.*;
import com.securitycentric.metacoretex.*;

import java.util.*;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  visigoth
 * @version
 */
public class AboutKbTableModel extends AbstractTableModel {
    
    public AboutKbTableModel() {
        
        keyVect = new Vector();
        descVect = new Vector();
        nameVect = new Vector();
        
        Iterator it = Init.allProbeVect.iterator();
        while (it.hasNext()) {
            Probe prb = (Probe)it.next();
            String name = prb.getName();
            Hashtable provs = prb.provides();
            Iterator kit = provs.keySet().iterator();
            while (kit.hasNext()) {
                String key = (String)kit.next();
                keyVect.add(key);
                descVect.add(provs.get(key));
                nameVect.add(name);
            }
            
        }
        colNames = new String [] {"KB Key","Description","Provided By"};
        
    }
    
    public int getRowCount() {
        
        return (keyVect.size());
        
    }
    
    public int getColumnCount() {
        
        return(3);
        
    }
    
    public String getColumnName(int column) {
        
        return(colNames[column]);
        
    }
    
    public Class getColumnClass(int column) {
        return(String.class);
    }
    
    public Object getValueAt(int row, int column) {
        
        switch (column) {
            
            case 0:
                return(keyVect.get(row));
            case 1:
                return(descVect.get(row));
            case 2:
                return(nameVect.get(row));
        }
        
        return(new String("WTF?"));
        
    }
    
    public Vector keyVect, descVect, nameVect;
    public String[] colNames;
}
