/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * ExTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.interfaces.*;
import com.securitycentric.metacoretex.lib.*;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  visigoth
 * @version $Id: ExTableModel.java,v 1.3 2003/06/08 06:56:45 visigoth_6 Exp $
 */
public class ExTableModel extends AbstractTableModel {
    
    public ExTableModel(Vector vector) {
        
        this.vector = vector;
        colNames = new String [] {"Probe", "Exception"};
        targIndex = -1;
        
    }
    
    public int getRowCount() {
        
        if (targIndex == -1)
            return(0);
        if (vector.size() == 0)
            return(0);
        
        int rows = ((Target)vector.get(targIndex)).exVect.size();
        return (rows);
        
    }
    
    public int getColumnCount() {
        
        return(2);
        
    }
    
    public String getColumnName(int column) {
        
        return(colNames[column]);
        
    }
    
    public Class getColumnClass(int column) {
        switch(column) {
            case 0:
                return(String.class);
            case 1:
                return(String.class);
        }
        return(String.class);
    }
    
    public Object getValueAt(int row, int column) {
        
        if (targIndex == -1)
            return(null);
        
        Target targTmp = (Target)vector.get(targIndex);
        ProbeException pe = (ProbeException)targTmp.exVect.get(row);
        
        switch (column) {
            
            case 0:
                //return(repTmp.getProbeName());
                return(pe.getProbeName());
            case 1:
                return(pe.getMessage());
        }
        
        return(new String("WTF?"));
        
    }
    
    public boolean isCellEditable(int row, int col) {
        return(false);
    }
    
    public Vector vector;
    public String[] colNames;
    public int targIndex;
}
