/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * GlobalOptionsTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.interfaces.*;

import java.util.*;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  visigoth
 * @version
 */
public class GlobalOptionsTableModel extends AbstractTableModel {
    
    public GlobalOptionsTableModel(Properties options) {
        
        prop = options;
        vector = new Vector();
        
        Iterator i = options.keySet().iterator();
        
        while (i.hasNext())
            vector.add(i.next());
            
        colNames = new String [] {"Option","Value"};
        
    }
    
    public int getRowCount() {
        
        return vector.size();
        
    }
    
    public int getColumnCount() {
        
        return(2);
        
    }
    
    public String getColumnName(int column) {
        
        return(colNames[column]);
        
    }
    
    public Class getColumnClass(int column) {
        /* Eventual cool renderer config
        switch (column) {
            case 0:
                return(String.class);
            case 1:
                return(Object.class);
        }
         */
        return(String.class);
    }
    
    public Object getValueAt(int row, int column) {
        
        String key = (String)vector.get(row);
        
        switch (column) {
            
            case 0:
                return(key);
            case 1:
                return(prop.getProperty(key));
        }
        
        return(new String("WTF?"));
        
    }
    
    public boolean isCellEditable(int row, int col) {
        if (col == 1)
            return(true);
        
        return(false);
    }
    
    public void setValueAt(Object obj, int row, int col) {
        
        String key = (String)vector.get(row);
        
        switch (col) {
            case 1:
                prop.setProperty(key, (String)obj);
                break;
        }
    }
    
    public Vector vector;
    public Properties prop;
    public String[] colNames;
}
