/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * OptionsTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.interfaces.*;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  visigoth
 * @version
 */
public class OptionsTableModel extends AbstractTableModel {
    
    public OptionsTableModel(Vector vector) {
        
        this.vector = vector;
        colNames = new String [] {"Option","Value"};
        
        if (vector.size() == 0)
            probeIndex = -1;
        else
            probeIndex = 0;
        
    }
    
    public int getRowCount() {
        if (probeIndex == -1)
            return(0);
        
        return (((Probe)vector.get(probeIndex)).getOptionKeys().size());
        
    }
    
    public int getColumnCount() {
        
        return(2);
        
    }
    
    public String getColumnName(int column) {
        
        return(colNames[column]);
        
    }
    
    public Class getColumnClass(int column) {
        return(String.class);
    }
    
    public Object getValueAt(int row, int column) {
        
        Probe tmpProbe = (Probe)vector.get(probeIndex);
        String key = (String)tmpProbe.getOptionKeys().get(row);
        
        switch (column) {
            
            case 0:
                return(key);
            case 1:
                return(tmpProbe.getOption(key));
        }
        
        return(new String("WTF?"));
        
    }
    
    public boolean isCellEditable(int row, int col) {
        if (col == 1)
            return(true);
        
        return(false);
    }
    
    public void setValueAt(Object obj, int row, int col) {
        
        Probe tmpProbe = (Probe)vector.get(probeIndex);
        String key = (String)tmpProbe.getOptionKeys().get(row);
        
        switch (col) {
            case 1:
                tmpProbe.addOption(key,(String)obj);
                //System.out.println("set " + key + " as " + (String)obj + " on " + tmpProbe.getName());
                break;
        }
    }
    
    
    public void setIndex(int ind) {
        if ( 0 <= ind && ind < vector.size())
            probeIndex = ind;
    }
    
    public Vector vector;
    protected int probeIndex;
    public String[] colNames;
}
