/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * AuthProbeTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.interfaces.*;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  visigoth
 * @version 
 */
public class ProbeTableModel extends AbstractTableModel {

    public ProbeTableModel(Vector vector) {

      this.vector = vector;
      colNames = new String [] {"Name","Enabled"};

    }

    public int getRowCount() {

      return (vector.size());

    }

    public int getColumnCount() {

      return(2);

    }

    public String getColumnName(int column) {

      return(colNames[column]);

    }
    
    public Class getColumnClass(int column) {
        switch(column) {
            case 0:
                return(String.class);
            case 1:
                return(Boolean.class);
        }
        return(String.class);
    }

    public Object getValueAt(int row, int column) {

      switch (column) {

        case 0:
                return(((Probe)vector.get(row)).getName());
        case 1:
                return(new Boolean(((Probe)vector.get(row)).isEnabled()));
      }

      return(new String("WTF?"));

    }
    
    public boolean isCellEditable(int row, int col) {
        if (col == 1)
            return(true);
        
        return(false);
    }
    
    public void setValueAt(Object obj, int row, int col) {
        switch (col) {
            case 1:
                ((Probe)vector.get(row)).setEnabled(((Boolean) obj).booleanValue());
                break;
        }
    }
    

    public Vector vector;
    public String[] colNames;
}
