/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * RepTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.interfaces.*;
import com.securitycentric.metacoretex.lib.*;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  visigoth
 * @version
 */
public class RepTableModel extends AbstractTableModel {
    
    public RepTableModel(Vector vector) {
        
        this.vector = vector;
        //colNames = new String [] {"Probe", "", "Report"};
        colNames = new String [] {"Probe", ""};
        targIndex = -1;
        
    }
    
    public int getRowCount() {
        
        if (targIndex == -1)
            return(0);
        if (vector.size() == 0)
            return(0);
        
        int rows = ((Target)vector.get(targIndex)).repVect.size();
        return (rows);
        
    }
    
    public int getColumnCount() {
        
        return(2);
        
    }
    
    public String getColumnName(int column) {
        
        return(colNames[column]);
        
    }
    
    public Class getColumnClass(int column) {
        switch(column) {
            case 0:
                return(String.class);
            case 1:
                return(Integer.class);
        }
        return(String.class);
    }
    
    public Object getValueAt(int row, int column) {
        
        if (targIndex == -1)
            return(null);
        
        Target targTmp = (Target)vector.get(targIndex);
        ProbeReport repTmp = (ProbeReport)targTmp.repVect.get(row);
        
        switch (column) {
            
            case 0:
                return(repTmp.getProbeName());
            case 1:
                return(new Integer(repTmp.getSeverity()));
            case 2:
                return(repTmp.getReport());
        }
        
        return(new String("WTF?"));
        
    }
    
    public boolean isCellEditable(int row, int col) {
        return(false);
    }
    
    public Vector vector;
    public String[] colNames;
    public int targIndex;
}
