/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * RepTargTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.interfaces.*;
import com.securitycentric.metacoretex.lib.*;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  visigoth
 * @version
 */
public class RepTargTableModel extends AbstractTableModel {
    
    public RepTargTableModel(Vector vector) {
        
        this.vector = vector;
        colNames = new String [] {"Target", "Reports", "I", "L", "M", "H", "Failures"};
        
    }
    
    public int getRowCount() {
        
        return (vector.size());
        
    }
    
    public int getColumnCount() {
        
        return(7);
        
    }
    
    public String getColumnName(int column) {
        
        return(colNames[column]);
        
    }
    
    public Class getColumnClass(int column) {
        switch(column) {
            case 0:
                return(String.class);
            case 1:
                return(String.class);
            case 2:
                return(String.class);
        }
        return(String.class);
    }
    
    public Object getValueAt(int row, int column) {
        
        int num;
        switch (column) {
            
            case 0:
                return(((Target)vector.get(row)).getHost());
            case 1:
                num = ((Target)vector.get(row)).repVect.size();
                return(String.valueOf(num));
            case 2:
                num = ((Target)vector.get(row)).getSeverityCount(0);
                return(String.valueOf(num));
            case 3:
                num = ((Target)vector.get(row)).getSeverityCount(1);
                return(String.valueOf(num));
            case 4:
                num = ((Target)vector.get(row)).getSeverityCount(2);
                return(String.valueOf(num));
            case 5:
                num = ((Target)vector.get(row)).getSeverityCount(3);
                return(String.valueOf(num));
            case 6:
                num = ((Target)vector.get(row)).exVect.size();
                return(String.valueOf(num));
        }
        
        return(new String("WTF?"));
        
    }
    
    public boolean isCellEditable(int row, int col) {
        return(false);
    }
    
    /*
    public void setValueAt(Object obj, int row, int col) {
    }
     */
    
    public Vector vector;
    public String[] colNames;
}
