/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * ScanTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.*;
import com.securitycentric.metacoretex.lib.*;
import com.securitycentric.metacoretex.interfaces.*;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;
import javax.swing.JProgressBar;
import javax.swing.JButton;

/**
 *
 * @author  visigoth
 * @version 
 */
public class ScanTableModel extends AbstractTableModel {

    public ScanTableModel(Vector vector) {

      this.vector = vector;
      colNames = new String [] {"Thread", "Target", "Progress", "Current Probe"};

    }

    public int getRowCount() {

      return (vector.size());

    }

    public int getColumnCount() {

      return(4);

    }

    public String getColumnName(int column) {

      return(colNames[column]);

    }
    
    public Class getColumnClass(int column) {
        switch(column) {
            case 0:
                return(String.class);
            case 1:
                return(String.class);
            case 2:
                return(JProgressBar.class);
            case 3:
                return(String.class);
        }
        return(String.class);
    }

    public Object getValueAt(int row, int column) {

      Attacker atk = (Attacker)vector.get(row);
      int num;
      switch (column) {

        case 0:
                return("Attacker Thread");
        case 1:
                return(atk.getTargName());
        case 2:
                return(atk.getProgress());
        case 3:
                return(atk.getProbeName());
      }

      return(new String("WTF?"));

    }
    
    public boolean isCellEditable(int row, int col) {
        return(false);
    }
    
    public Vector vector;
    public String[] colNames;
}
