/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * TargetTableModel.java
 *
 * Created on April 26, 2003, 12:30 AM
 */

package com.securitycentric.metacoretex.adapters;

import com.securitycentric.metacoretex.interfaces.*;
import com.securitycentric.metacoretex.lib.*;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author  visigoth
 * @version
 */
public class TargetTableModel extends AbstractTableModel {
    
    public TargetTableModel(Vector vector) {
        
        this.vector = vector;
        colNames = new String [] {"Targets"};
        
    }
    
    public int getRowCount() {
        
        return (vector.size());
        
    }
    
    public int getColumnCount() {
        
        return(1);
        
    }
    
    public String getColumnName(int column) {
        
        return(colNames[column]);
        
    }
    
    public Class getColumnClass(int column) {
        return(String.class);
    }
    
    public Object getValueAt(int row, int column) {
        
        switch (column) {
            
            case 0:
                return(((Target)vector.get(row)).getHost());
        }
        
        return(new String("WTF?"));
        
    }
    
    public boolean isCellEditable(int row, int col) {
        return(true);
    }
    
    public void setValueAt(Object obj, int row, int col) {
        
        switch(col) {
            case 0:
                ((Target)vector.get(row)).setHost((String)obj);
                break;
        }
    }
    
    public Vector vector;
    public String[] colNames;
}
