/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * AboutMetaCoretex.java
 *
 * Created on May 7, 2003, 11:53 AM
 */

package com.securitycentric.metacoretex.gui;

import com.securitycentric.metacoretex.*;
import com.securitycentric.metacoretex.adapters.*;
import com.securitycentric.metacoretex.lib.*;
import com.securitycentric.metacoretex.interfaces.*;

import javax.swing.ListSelectionModel;
import javax.swing.event.*;

/**
 *
 * @author  visigoth
 */
public class AboutProbes extends javax.swing.JFrame {
    
    /** Creates new form AboutMetaCoretex */
    public AboutProbes() {
        int x = ProbeToolz.nextProbeId();
        initComponents();
        probeIdLabel.setText("Next Probe Id: " + String.valueOf(x));
        
        ListSelectionModel rowSM = aboutTable.getSelectionModel();
        
        rowSM.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                //Ignore extra messages.
                int ind = aboutTable.getSelectedRow();
                helpText.setText(((Probe)Init.allProbeVect.get(ind)).getHelp());
                helpText.setCaretPosition(0);
            }
        });
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        probeIdLabel = new javax.swing.JLabel();
        splitPane = new javax.swing.JSplitPane();
        scrollPane = new javax.swing.JScrollPane();
        aboutTable = new javax.swing.JTable();
        helpPane = new javax.swing.JScrollPane();
        helpText = new javax.swing.JTextArea();

        setTitle("About Probes");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        probeIdLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        getContentPane().add(probeIdLabel, java.awt.BorderLayout.NORTH);

        splitPane.setDividerLocation(400);
        splitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        aboutTable.setModel(new AboutProbeTableModel(Init.allProbeVect));
        scrollPane.setViewportView(aboutTable);

        splitPane.setLeftComponent(scrollPane);

        helpPane.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        helpText.setLineWrap(true);
        helpText.setRows(8);
        helpText.setText("Highlight a probe to review the help provided for that probe.");
        helpText.setWrapStyleWord(true);
        helpPane.setViewportView(helpText);

        splitPane.setRightComponent(helpPane);

        getContentPane().add(splitPane, java.awt.BorderLayout.EAST);

        pack();
    }//GEN-END:initComponents
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        setVisible(false);
        dispose();
    }//GEN-LAST:event_exitForm
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JLabel probeIdLabel;
    private javax.swing.JScrollPane helpPane;
    private javax.swing.JTable aboutTable;
    private javax.swing.JTextArea helpText;
    private javax.swing.JSplitPane splitPane;
    // End of variables declaration//GEN-END:variables
    
}
