/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * MainWindow.java
 *
 * Created on May 5, 2003, 10:42 AM
 */

package com.securitycentric.metacoretex.gui;

import com.securitycentric.metacoretex.*;
import com.securitycentric.metacoretex.adapters.*;
import com.securitycentric.metacoretex.lib.*;
import com.securitycentric.metacoretex.interfaces.*;
import com.securitycentric.metacoretex.gui.wizards.*;

import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.Component;
import java.io.*;
import java.util.*;

/**
 *
 * @author  visigoth
 */
public class MainWindow extends javax.swing.JFrame {
    
    /** Creates new form MainWindow */
    public MainWindow() {
        preInit();
        initComponents();
        postInit();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        targetPopup = new javax.swing.JPopupMenu();
        filePopItem = new javax.swing.JMenuItem();
        namePopItem = new javax.swing.JMenuItem();
        deskPane = new javax.swing.JDesktopPane();
        homeFrame = new javax.swing.JInternalFrame();
        homeSplit = new javax.swing.JSplitPane();
        homeTargPane = new javax.swing.JScrollPane();
        targTable = new javax.swing.JTable();
        homePane = new javax.swing.JScrollPane();
        optionTable = new javax.swing.JTable();
        homeToolBar = new javax.swing.JToolBar();
        fireButton = new javax.swing.JButton();
        addTargButton = new javax.swing.JButton();
        minusTargButton = new javax.swing.JButton();
        saveConfigButton = new javax.swing.JButton();
        loadConfigButton = new javax.swing.JButton();
        targFrame = new javax.swing.JInternalFrame();
        probeFrame = new javax.swing.JInternalFrame();
        tabPane = new javax.swing.JTabbedPane();
        probeToolBar = new javax.swing.JToolBar();
        helpButton = new javax.swing.JButton();
        loadProbeButton = new javax.swing.JButton();
        scanFrame = new javax.swing.JInternalFrame();
        scanPane = new javax.swing.JScrollPane();
        scanTable = new javax.swing.JTable();
        scanToolBar = new javax.swing.JToolBar();
        stopButton = new javax.swing.JButton();
        repFrame = new javax.swing.JInternalFrame();
        repSplit = new javax.swing.JSplitPane();
        repTargPane = new javax.swing.JScrollPane();
        repTargTable = new javax.swing.JTable();
        exSplit = new javax.swing.JSplitPane();
        jSplitPane1 = new javax.swing.JSplitPane();
        repPane = new javax.swing.JScrollPane();
        repTable = new javax.swing.JTable();
        repTxtPane = new javax.swing.JScrollPane();
        repTextArea = new javax.swing.JTextArea();
        exPane = new javax.swing.JScrollPane();
        exTable = new javax.swing.JTable();
        repToolBar = new javax.swing.JToolBar();
        repSaveButton = new javax.swing.JButton();
        repLoadButton = new javax.swing.JButton();
        toolBar = new javax.swing.JToolBar();
        homeButton = new javax.swing.JButton();
        probeButton = new javax.swing.JButton();
        scanButton = new javax.swing.JButton();
        reportButton = new javax.swing.JButton();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        saveMenu = new javax.swing.JMenu();
        saveScanItem = new javax.swing.JMenuItem();
        saveRepItem = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        loadMenu = new javax.swing.JMenu();
        loadScanItem = new javax.swing.JMenuItem();
        loadRepItem = new javax.swing.JMenuItem();
        loadProbeItem = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        exitItem = new javax.swing.JMenuItem();
        editMenu = new javax.swing.JMenu();
        toolsMenu = new javax.swing.JMenu();
        updateMenu = new javax.swing.JMenu();
        updateInterItem = new javax.swing.JMenuItem();
        updateProbeItem = new javax.swing.JMenuItem();
        updateConfItem = new javax.swing.JMenuItem();
        updateAllItem = new javax.swing.JMenuItem();
        genMenu = new javax.swing.JMenu();
        verProbeItem = new javax.swing.JMenuItem();
        bannerProbeItem = new javax.swing.JMenuItem();
        sqlProbeItem = new javax.swing.JMenuItem();
        cmdProbeItem = new javax.swing.JMenuItem();
        oraProbeItem = new javax.swing.JMenuItem();
        compileItem = new javax.swing.JMenuItem();
        sep1 = new javax.swing.JSeparator();
        clearRepItem = new javax.swing.JMenuItem();
        jSeparator3 = new javax.swing.JSeparator();
        submitProbeItem = new javax.swing.JMenuItem();
        windowMenu = new javax.swing.JMenu();
        homeFrameItem = new javax.swing.JMenuItem();
        probeFrameItem = new javax.swing.JMenuItem();
        scanFrameItem = new javax.swing.JMenuItem();
        repFrameItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        aboutItem = new javax.swing.JMenuItem();
        aboutProbeItem = new javax.swing.JMenuItem();
        aboutKbItem = new javax.swing.JMenuItem();

        filePopItem.setText("From File");
        filePopItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filePopItemActionPerformed(evt);
            }
        });

        targetPopup.add(filePopItem);

        namePopItem.setText("Host Name");
        namePopItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                namePopItemActionPerformed(evt);
            }
        });

        targetPopup.add(namePopItem);

        setTitle("MetaCoretex  --==<< visigoth >>==--");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        homeFrame.setTitle("Global Configuration");
        homeFrame.setFrameIcon(new javax.swing.ImageIcon(""));
        homeFrame.setPreferredSize(new java.awt.Dimension(200, 400));
        try {
            homeFrame.setSelected(true);
        } catch (java.beans.PropertyVetoException e1) {
            e1.printStackTrace();
        }
        homeFrame.setVisible(true);
        homeSplit.setDividerLocation(200);
        targTable.setModel(targTableModel);
        homeTargPane.setViewportView(targTable);

        homeSplit.setLeftComponent(homeTargPane);

        optionTable.setModel(gloptTableModel);
        homePane.setViewportView(optionTable);

        homeSplit.setRightComponent(homePane);

        homeFrame.getContentPane().add(homeSplit, java.awt.BorderLayout.CENTER);

        fireButton.setBackground(new java.awt.Color(204, 0, 0));
        fireButton.setText("LAUNCH");
        fireButton.setToolTipText("Fire the current scan");
        fireButton.setBorder(new javax.swing.border.EtchedBorder());
        fireButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fireButtonActionPerformed(evt);
            }
        });

        homeToolBar.add(fireButton);

        addTargButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/plus.gif")));
        addTargButton.setToolTipText("Add Target(s)");
        addTargButton.setBorder(new javax.swing.border.EtchedBorder());
        addTargButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                addTargButtonMouseClicked(evt);
            }
        });

        homeToolBar.add(addTargButton);

        minusTargButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/minus.gif")));
        minusTargButton.setToolTipText("Remove Target(s)");
        minusTargButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                minusTargButtonActionPerformed(evt);
            }
        });

        homeToolBar.add(minusTargButton);

        saveConfigButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/save.gif")));
        saveConfigButton.setToolTipText("Save Scan Configuration");
        saveConfigButton.setBorder(new javax.swing.border.EtchedBorder());
        saveConfigButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveConfigButtonActionPerformed(evt);
            }
        });

        homeToolBar.add(saveConfigButton);

        loadConfigButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/open.gif")));
        loadConfigButton.setToolTipText("Load Scan Configuration");
        loadConfigButton.setBorder(new javax.swing.border.EtchedBorder());
        loadConfigButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadConfigButtonActionPerformed(evt);
            }
        });

        homeToolBar.add(loadConfigButton);

        homeFrame.getContentPane().add(homeToolBar, java.awt.BorderLayout.SOUTH);

        homeFrame.setBounds(0, 0, -1, -1);
        deskPane.add(homeFrame, javax.swing.JLayeredPane.DEFAULT_LAYER);

        targFrame.getContentPane().setLayout(new javax.swing.BoxLayout(targFrame.getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        targFrame.setVisible(true);
        targFrame.setBounds(0, 0, -1, -1);
        deskPane.add(targFrame, javax.swing.JLayeredPane.DEFAULT_LAYER);

        probeFrame.getContentPane().setLayout(new javax.swing.BoxLayout(probeFrame.getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        probeFrame.setTitle("Probe Configuration");
        probeFrame.setVisible(true);
        tabPane.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 1, 1, 1)));
        tabPane.setPreferredSize(new java.awt.Dimension(10, 10));
        probeFrame.getContentPane().add(tabPane);

        helpButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/help.gif")));
        helpButton.setToolTipText("Probe Specific Help");
        helpButton.setBorder(new javax.swing.border.EtchedBorder());
        helpButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                helpButtonMouseClicked(evt);
            }
        });

        probeToolBar.add(helpButton);

        loadProbeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/open.gif")));
        loadProbeButton.setToolTipText("Load Probe From File");
        loadProbeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadProbeButtonActionPerformed(evt);
            }
        });

        probeToolBar.add(loadProbeButton);

        probeFrame.getContentPane().add(probeToolBar);

        probeFrame.setBounds(0, 0, 81, 32);
        deskPane.add(probeFrame, javax.swing.JLayeredPane.DEFAULT_LAYER);

        scanFrame.getContentPane().setLayout(new javax.swing.BoxLayout(scanFrame.getContentPane(), javax.swing.BoxLayout.Y_AXIS));

        scanFrame.setTitle("Scan Status");
        scanFrame.setVisible(true);
        scanTable.setModel(scanTableModel);
        scanTable.setShowVerticalLines(false);
        scanPane.setViewportView(scanTable);

        scanFrame.getContentPane().add(scanPane);

        stopButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/stop.gif")));
        stopButton.setToolTipText("Stop the Selected Attack Thread");
        stopButton.setBorder(new javax.swing.border.EtchedBorder());
        stopButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stopButtonActionPerformed(evt);
            }
        });

        scanToolBar.add(stopButton);

        scanFrame.getContentPane().add(scanToolBar);

        scanFrame.setBounds(0, 0, -1, -1);
        deskPane.add(scanFrame, javax.swing.JLayeredPane.DEFAULT_LAYER);

        repFrame.setTitle("Scan Reports");
        repFrame.setVisible(true);
        repSplit.setDividerLocation(100);
        repSplit.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        repTargTable.setModel(repTargTableModel);
        repTargTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_ALL_COLUMNS);
        repTargTable.setShowVerticalLines(false);
        repTargPane.setViewportView(repTargTable);

        repSplit.setTopComponent(repTargPane);

        exSplit.setDividerLocation(200);
        exSplit.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setDividerLocation(200);
        repTable.setModel(repTableModel);
        repPane.setViewportView(repTable);

        jSplitPane1.setLeftComponent(repPane);

        repTxtPane.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        repTxtPane.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        repTextArea.setEditable(false);
        repTxtPane.setViewportView(repTextArea);

        jSplitPane1.setRightComponent(repTxtPane);

        exSplit.setTopComponent(jSplitPane1);

        exTable.setModel(exTableModel);
        exPane.setViewportView(exTable);

        exSplit.setBottomComponent(exPane);

        repSplit.setBottomComponent(exSplit);

        repFrame.getContentPane().add(repSplit, java.awt.BorderLayout.CENTER);

        repSaveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/save.gif")));
        repSaveButton.setToolTipText("Save Report");
        repSaveButton.setBorder(new javax.swing.border.EtchedBorder());
        repSaveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                repSaveButtonActionPerformed(evt);
            }
        });

        repToolBar.add(repSaveButton);

        repLoadButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/open.gif")));
        repLoadButton.setToolTipText("Load Report");
        repLoadButton.setBorder(new javax.swing.border.EtchedBorder());
        repLoadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                repLoadButtonActionPerformed(evt);
            }
        });

        repToolBar.add(repLoadButton);

        repFrame.getContentPane().add(repToolBar, java.awt.BorderLayout.SOUTH);

        repFrame.setBounds(0, 0, -1, -1);
        deskPane.add(repFrame, javax.swing.JLayeredPane.DEFAULT_LAYER);

        getContentPane().add(deskPane, java.awt.BorderLayout.CENTER);

        toolBar.setOrientation(1);
        homeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/home.gif")));
        homeButton.setToolTipText("Home");
        homeButton.setBorder(new javax.swing.border.EtchedBorder());
        homeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                homeButtonActionPerformed(evt);
            }
        });

        toolBar.add(homeButton);

        probeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/chip.gif")));
        probeButton.setToolTipText("Probe Configuration");
        probeButton.setBorder(new javax.swing.border.EtchedBorder());
        probeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                probeButtonActionPerformed(evt);
            }
        });

        toolBar.add(probeButton);

        scanButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/scan.gif")));
        scanButton.setToolTipText("Scan Status");
        scanButton.setBorder(new javax.swing.border.EtchedBorder());
        scanButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                scanButtonActionPerformed(evt);
            }
        });

        toolBar.add(scanButton);

        reportButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/com/securitycentric/metacoretex/images/report.gif")));
        reportButton.setToolTipText("Scan Reports");
        reportButton.setBorder(new javax.swing.border.EtchedBorder());
        reportButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportButtonActionPerformed(evt);
            }
        });

        toolBar.add(reportButton);

        getContentPane().add(toolBar, java.awt.BorderLayout.WEST);

        fileMenu.setText("File");
        saveMenu.setText("Save...");
        saveScanItem.setText("Scan Configuration");
        saveScanItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveScanItemActionPerformed(evt);
            }
        });

        saveMenu.add(saveScanItem);

        saveRepItem.setText("Report");
        saveRepItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveRepItemActionPerformed(evt);
            }
        });

        saveMenu.add(saveRepItem);

        fileMenu.add(saveMenu);

        fileMenu.add(jSeparator1);

        loadMenu.setText("Load...");
        loadScanItem.setText("Scan Configuration");
        loadScanItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadScanItemActionPerformed(evt);
            }
        });

        loadMenu.add(loadScanItem);

        loadRepItem.setText("Report");
        loadRepItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadRepItemActionPerformed(evt);
            }
        });

        loadMenu.add(loadRepItem);

        loadProbeItem.setText("Probe");
        loadProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                loadProbeItemActionPerformed(evt);
            }
        });

        loadMenu.add(loadProbeItem);

        fileMenu.add(loadMenu);

        fileMenu.add(jSeparator2);

        exitItem.setText("exit");
        exitItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitItem);

        menuBar.add(fileMenu);

        editMenu.setText("Edit");
        menuBar.add(editMenu);

        toolsMenu.setText("Tools");
        updateMenu.setText("Update...");
        updateInterItem.setText("Interactive...");
        updateInterItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateInterItemActionPerformed(evt);
            }
        });

        updateMenu.add(updateInterItem);

        updateProbeItem.setText("Probes");
        updateProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateProbeItemActionPerformed(evt);
            }
        });

        updateMenu.add(updateProbeItem);

        updateConfItem.setText("Config Files");
        updateConfItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateConfItemActionPerformed(evt);
            }
        });

        updateMenu.add(updateConfItem);

        updateAllItem.setText("All");
        updateAllItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateAllItemActionPerformed(evt);
            }
        });

        updateMenu.add(updateAllItem);

        toolsMenu.add(updateMenu);

        genMenu.setText("Generate...");
        verProbeItem.setText("Version Probe");
        verProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                verProbeItemActionPerformed(evt);
            }
        });

        genMenu.add(verProbeItem);

        bannerProbeItem.setText("Banner Grabber Probe");
        bannerProbeItem.setEnabled(false);
        bannerProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bannerProbeItemActionPerformed(evt);
            }
        });

        genMenu.add(bannerProbeItem);

        sqlProbeItem.setText("SQL Query Probe");
        sqlProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sqlProbeItemActionPerformed(evt);
            }
        });

        genMenu.add(sqlProbeItem);

        cmdProbeItem.setText("Command Probe");
        cmdProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdProbeItemActionPerformed(evt);
            }
        });

        genMenu.add(cmdProbeItem);

        oraProbeItem.setText("Oracle PL/SQL Probe");
        oraProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                oraProbeItemActionPerformed(evt);
            }
        });

        genMenu.add(oraProbeItem);

        toolsMenu.add(genMenu);

        compileItem.setText("Compile Probe");
        compileItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                compileItemActionPerformed(evt);
            }
        });

        toolsMenu.add(compileItem);

        toolsMenu.add(sep1);

        clearRepItem.setText("Clear Reports");
        clearRepItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                clearRepItemActionPerformed(evt);
            }
        });

        toolsMenu.add(clearRepItem);

        toolsMenu.add(jSeparator3);

        submitProbeItem.setText("Submit Probe Source");
        submitProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                submitProbeItemActionPerformed(evt);
            }
        });

        toolsMenu.add(submitProbeItem);

        menuBar.add(toolsMenu);

        windowMenu.setText("Window");
        homeFrameItem.setText("Home");
        homeFrameItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                homeFrameItemActionPerformed(evt);
            }
        });

        windowMenu.add(homeFrameItem);

        probeFrameItem.setText("Probe Config");
        probeFrameItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                probeFrameItemActionPerformed(evt);
            }
        });

        windowMenu.add(probeFrameItem);

        scanFrameItem.setText("Scan Status");
        scanFrameItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                scanFrameItemActionPerformed(evt);
            }
        });

        windowMenu.add(scanFrameItem);

        repFrameItem.setText("Reports");
        repFrameItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                repFrameItemActionPerformed(evt);
            }
        });

        windowMenu.add(repFrameItem);

        menuBar.add(windowMenu);

        helpMenu.setText("Help");
        aboutItem.setText("About...");
        aboutItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutItem);

        aboutProbeItem.setText("About Probes...");
        aboutProbeItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutProbeItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutProbeItem);

        aboutKbItem.setText("About KB (developers)...");
        aboutKbItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutKbItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutKbItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        pack();
    }//GEN-END:initComponents

    private void submitProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_submitProbeItemActionPerformed
        JFileChooser chooser = new JFileChooser(Init.userDir);
        chooser.setDialogTitle("Probe JAVA Source File");
        int ret = chooser.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION)
            new Thread(new ProbeSubmitter(chooser.getSelectedFile())).start();
    }//GEN-LAST:event_submitProbeItemActionPerformed

    private void aboutKbItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutKbItemActionPerformed
        new AboutKb().show();
    }//GEN-LAST:event_aboutKbItemActionPerformed

    private void loadProbeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadProbeButtonActionPerformed
        loadProbeItemActionPerformed(evt);
    }//GEN-LAST:event_loadProbeButtonActionPerformed

    private void oraProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_oraProbeItemActionPerformed
        String tempDir = Init.config.getProperty("template.dir");
        ProbeWizard prwz = new ProbeWizard(new File(tempDir+"/OracleProbe.java"));
        prwz.addPanel(new GeneralPanel());
        prwz.addPanel(new OraclePlsqlPanel());
        prwz.addPanel(new ReportPanel());
        prwz.show();
    }//GEN-LAST:event_oraProbeItemActionPerformed

    private void updateInterItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateInterItemActionPerformed
        UpdateWizard1 uwiz = new UpdateWizard1();
        new Thread(uwiz).start();
    }//GEN-LAST:event_updateInterItemActionPerformed

    private void cmdProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdProbeItemActionPerformed
        //
        String tempDir = Init.config.getProperty("template.dir");
        ProbeWizard prwz = new ProbeWizard(new File(tempDir+"/CommandProbe.java"));
        prwz.addPanel(new GeneralPanel());
        prwz.addPanel(new CommandProbePanel());
        prwz.addPanel(new ReportPanel());
        Init.centerWindow(prwz);
        prwz.show();
    }//GEN-LAST:event_cmdProbeItemActionPerformed

    private void updateAllItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateAllItemActionPerformed
        new Updater().start();
    }//GEN-LAST:event_updateAllItemActionPerformed

    private void updateConfItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateConfItemActionPerformed
        new Updater(Updater.UPDATE_CONFIG).start();
    }//GEN-LAST:event_updateConfItemActionPerformed

    private void updateProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateProbeItemActionPerformed
        new Updater(Updater.UPDATE_PROBES).start();
    }//GEN-LAST:event_updateProbeItemActionPerformed

    private void sqlProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sqlProbeItemActionPerformed
        //
        String tempDir = Init.config.getProperty("template.dir");
        ProbeWizard prwz = new ProbeWizard(new File(tempDir+"/SqlProbe.java"));
        prwz.addPanel(new GeneralPanel());
        prwz.addPanel(new SqlProbePanel());
        prwz.addPanel(new ReportPanel());
        Init.centerWindow(prwz);
        prwz.show();
    }//GEN-LAST:event_sqlProbeItemActionPerformed

    private void bannerProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bannerProbeItemActionPerformed
        //
        String tempDir = Init.config.getProperty("template.dir");
        ProbeWizard prwz = new ProbeWizard(new File(tempDir+"/BannerProbe.java"));
        prwz.addPanel(new GeneralPanel());
        prwz.addPanel(new ReportPanel());
        Init.centerWindow(prwz);
        prwz.show();
    }//GEN-LAST:event_bannerProbeItemActionPerformed

    private void compileItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_compileItemActionPerformed
        //
        JFileChooser chooser = new JFileChooser(Init.userDir);
        chooser.setDialogTitle("Probe JAVA Source File");
        int ret = chooser.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION)
            ProbeToolz.compileProbe(chooser.getSelectedFile());
    }//GEN-LAST:event_compileItemActionPerformed

    private void verProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_verProbeItemActionPerformed
        //
        String tempDir = Init.config.getProperty("template.dir");
        ProbeWizard prwz = new ProbeWizard(new File(tempDir+"/VersionTest.java"));
        prwz.addPanel(new GeneralPanel());
        prwz.addPanel(new VersionProbePanel1());
        prwz.addPanel(new ReportPanel());
        Init.centerWindow(prwz);
        prwz.show();
    }//GEN-LAST:event_verProbeItemActionPerformed

    private void loadRepItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadRepItemActionPerformed
        //
        repLoadButtonActionPerformed(evt);
    }//GEN-LAST:event_loadRepItemActionPerformed
        
    private void clearRepItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearRepItemActionPerformed
        Init.clearProbeReports();
        repTextArea.setText("No Reports");
        repTargTable.revalidate();
        repTargTable.repaint();
        repTable.revalidate();
        repTable.repaint();
        exTable.revalidate();
        exTable.repaint();
    }//GEN-LAST:event_clearRepItemActionPerformed
    
    private void repLoadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_repLoadButtonActionPerformed
        
        toFront(repFrame);
        JFileChooser chooser = new JFileChooser(Init.userDir);
        chooser.setDialogTitle("Load MetaCoretex Report");
        int retVal = chooser.showOpenDialog(this);
        if (retVal == JFileChooser.APPROVE_OPTION) {
            ReportToolz.LoadReport(chooser.getSelectedFile());
            repTargTable.revalidate();
            repTargTable.repaint();
            repTable.revalidate();
            repTable.repaint();
        }
    }//GEN-LAST:event_repLoadButtonActionPerformed
    
    private void helpButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_helpButtonMouseClicked
        //
        ProbeHelp phlp = new ProbeHelp(null, false);
        phlp.setProbeName(Init.selectedProbe.getName());
        phlp.setProbeHelp(Init.selectedProbe.getHelp());
        Init.centerWindow(phlp);
        phlp.show();
    }//GEN-LAST:event_helpButtonMouseClicked
    
    private void loadProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadProbeItemActionPerformed
        
        int index = -1;
        JFileChooser chooser = new JFileChooser(Init.userDir);
        chooser.setDialogTitle("Load Probe Class");
        int ret = chooser.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            Probe tmpPro = ProbeToolz.loadProbeFromFile(chooser.getSelectedFile());
            int id = tmpPro.getProbeId();
            ProbeToolz.removeProbe(id);
            
            index = ProbeToolz.getIndex(Init.allProbeVect, tmpPro);
            if (index != -1) {
                Init.loadProbe(tmpPro, index);
                displayProbes();
            } else
                JOptionPane.showMessageDialog(this, "Probe Dependencies Failed!", "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_loadProbeItemActionPerformed
    
    private void saveRepItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveRepItemActionPerformed
        //
        repSaveButtonActionPerformed(evt);
    }//GEN-LAST:event_saveRepItemActionPerformed
    
    private void stopButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stopButtonActionPerformed
        //
        Init.stopAttacker(scanTable.getSelectedRow());
    }//GEN-LAST:event_stopButtonActionPerformed
    
    private void filePopItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filePopItemActionPerformed
        //
        JFileChooser chooser = new JFileChooser(Init.userDir);
        chooser.setDialogTitle("Load Targets from File");
        int ret = chooser.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION)
            Init.loadTargetFile(chooser.getSelectedFile());
        targTable.revalidate();
        targTable.repaint();
    }//GEN-LAST:event_filePopItemActionPerformed
    
    private void loadConfigButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadConfigButtonActionPerformed
        //
        JFileChooser chooser = new JFileChooser(Init.userDir);
        chooser.setDialogTitle("Load Scan Configuration");
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION)
            Init.LoadConfig(chooser.getSelectedFile());
    }//GEN-LAST:event_loadConfigButtonActionPerformed
    
    private void saveConfigButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveConfigButtonActionPerformed
        //
        JFileChooser chooser = new JFileChooser(Init.userDir);
        chooser.setDialogTitle("Save Scan Configuration");
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION)
            Init.SaveConfig(chooser.getSelectedFile());
    }//GEN-LAST:event_saveConfigButtonActionPerformed
    
    private void repSaveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_repSaveButtonActionPerformed
        //
        JFileChooser chooser = new JFileChooser(Init.userDir);
        chooser.setDialogTitle("Save MetaCoretex Report");
        int returnVal = chooser.showSaveDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION)
            ReportToolz.SaveReport(chooser.getSelectedFile());
    }//GEN-LAST:event_repSaveButtonActionPerformed
    
    private void minusTargButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_minusTargButtonActionPerformed
        //
        int row[] = targTable.getSelectedRows();
        for (int i = 0; i < row.length; i++)
            Init.targVect.remove(row[i]);
        targTable.revalidate();
        targTable.repaint();
    }//GEN-LAST:event_minusTargButtonActionPerformed
    
    private void loadScanItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_loadScanItemActionPerformed
        //
        loadConfigButtonActionPerformed(evt);
    }//GEN-LAST:event_loadScanItemActionPerformed
    
    private void saveScanItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveScanItemActionPerformed
        //
        saveConfigButtonActionPerformed(evt);
    }//GEN-LAST:event_saveScanItemActionPerformed
    
    private void namePopItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_namePopItemActionPerformed
        //
        Init.targVect.add(new Target("NewHost"));
        targTable.revalidate();
        targTable.repaint();
    }//GEN-LAST:event_namePopItemActionPerformed
    
    private void addTargButtonMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_addTargButtonMouseClicked
        //
        targetPopup.show(evt.getComponent(), evt.getX(), evt.getY());
    }//GEN-LAST:event_addTargButtonMouseClicked
    
    private void reportButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportButtonActionPerformed
        //
        toFront(repFrame);
    }//GEN-LAST:event_reportButtonActionPerformed
    
    private void scanButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_scanButtonActionPerformed
        //
        toFront(scanFrame);
    }//GEN-LAST:event_scanButtonActionPerformed
    
    private void probeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_probeButtonActionPerformed
        //
        toFront(probeFrame);
    }//GEN-LAST:event_probeButtonActionPerformed
    
    private void homeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_homeButtonActionPerformed
        //
        toFront(homeFrame);
    }//GEN-LAST:event_homeButtonActionPerformed
    
    private void aboutProbeItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutProbeItemActionPerformed
        //
        AboutProbes probout = new AboutProbes();
        Init.centerWindow(probout);
        probout.show();
        
    }//GEN-LAST:event_aboutProbeItemActionPerformed
    
    private void aboutItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutItemActionPerformed
        // Add your handling code here:
        AboutMetaCoretex about = new AboutMetaCoretex();
        Init.centerWindow(about);
        about.show();
    }//GEN-LAST:event_aboutItemActionPerformed
    
    private void fireButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fireButtonActionPerformed
        //
        toFront(scanFrame);
        clearRepItemActionPerformed(null);
        Init.fire();
        scanTable.revalidate();
        scanTable.repaint();
    }//GEN-LAST:event_fireButtonActionPerformed
        
    private void repFrameItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_repFrameItemActionPerformed
        //
        toFront(repFrame);
    }//GEN-LAST:event_repFrameItemActionPerformed
    
    private void exitItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitItemActionPerformed
        //
        Init.ShutDown();
    }//GEN-LAST:event_exitItemActionPerformed
    
    private void homeFrameItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_homeFrameItemActionPerformed
        //
        toFront(homeFrame);
    }//GEN-LAST:event_homeFrameItemActionPerformed
    
    private void scanFrameItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_scanFrameItemActionPerformed
        //
        toFront(scanFrame);
    }//GEN-LAST:event_scanFrameItemActionPerformed
    
    private void probeFrameItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_probeFrameItemActionPerformed
        //
        toFront(probeFrame);
    }//GEN-LAST:event_probeFrameItemActionPerformed
    
    public void displayProbes() {
        
        tabPane.removeAll();
        
        Iterator famIter = Init.probeVectHash.keySet().iterator();
        while (famIter.hasNext()) {
            String fam = (String)famIter.next();
            tabPane.add(fam, new ProbePanel((Vector)Init.probeVectHash.get(fam)));
        }
    }
    
    private void postInit() {
        
        displayProbes();
        
        try {
            probeFrame.setMaximum(true);
            scanFrame.setMaximum(true);
            homeFrame.setMaximum(true);
            targFrame.setMaximum(true);
            repFrame.setMaximum(true);
            
            toFront(homeFrame);
            deskPane.grabFocus();
        } catch (java.beans.PropertyVetoException pe) {
            pe.printStackTrace();
        }
        
        scanTable.setDefaultRenderer(JProgressBar.class, new JProgressBarRenderer(0,Init.allProbeVect.size()));
        targTable.setDefaultEditor(String.class, new JTableStringEditor());
        optionTable.setDefaultEditor(String.class, new JTableStringEditor());
        
        // This could eventually work :) automagic rendering
        //optionTable.setDefaultRenderer(Object.class, objr);
        
        repTable.setDefaultRenderer(Integer.class, new JLabelRenderer());
        //exTable.setDefaultRenderer(String.class, new JTextAreaRenderer());
        
        repTable.getColumnModel().getColumn(1).setMaxWidth(20);
        repTable.doLayout();
        
        repTargTable.getColumnModel().getColumn(2).setMaxWidth(30);
        repTargTable.getColumnModel().getColumn(3).setMaxWidth(30);
        repTargTable.getColumnModel().getColumn(4).setMaxWidth(30);
        repTargTable.getColumnModel().getColumn(5).setMaxWidth(30);
        repTargTable.getColumnModel().getColumn(2).setHeaderRenderer(new JLabelRenderer(0));
        repTargTable.getColumnModel().getColumn(3).setHeaderRenderer(new JLabelRenderer(1));
        repTargTable.getColumnModel().getColumn(4).setHeaderRenderer(new JLabelRenderer(2));
        repTargTable.getColumnModel().getColumn(5).setHeaderRenderer(new JLabelRenderer(3));
        repTargTable.doLayout();
        
        exTable.getColumnModel().getColumn(0).setMaxWidth(150);
        exTable.getColumnModel().getColumn(0).setPreferredWidth(150);
        exTable.doLayout();
        
        
        /* Set up a bunch of ListSelectionListeners for tables.
         */
        repTargTable.getSelectionModel().addListSelectionListener( new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent ev) {
                repTableModel.targIndex = repTargTable.getSelectedRow();
                exTableModel.targIndex = repTargTable.getSelectedRow();
                repTable.revalidate();
                repTable.repaint();
                exTable.revalidate();
                exTable.repaint();
            }
        });
        
        repTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent ev) {
                int sel = repTable.getSelectedRow();
                if (sel != -1) {
                    if (sel >= repTable.getModel().getRowCount())
                        sel = 0;
                    repTextArea.setText((String)repTable.getModel().getValueAt(sel, 2));
                    repTextArea.setCaretPosition(0);
                }
            }
        });
        
        pack();
    }
    
    public void updateScanStatus() {
        scanTable.repaint();
    }
    
    private void preInit() {
        
        repTableModel = new RepTableModel(Init.reportVect);
        exTableModel = new ExTableModel(Init.reportVect);
        repTargTableModel = new RepTargTableModel(Init.reportVect);
        scanTableModel = new ScanTableModel(Init.attackVect);
        targTableModel = new TargetTableModel(Init.targVect);
        gloptTableModel = new GlobalOptionsTableModel(Init.config);
        
    }
    
    public void toFront(JInternalFrame fr) {
        fr.moveToFront();
        try{
            fr.setSelected(true);
        } catch (java.beans.PropertyVetoException pe) {
            JOptionPane.showMessageDialog(null, pe.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        Init.ShutDown();
    }//GEN-LAST:event_exitForm
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutItem;
    private javax.swing.JMenuItem aboutKbItem;
    private javax.swing.JMenuItem aboutProbeItem;
    private javax.swing.JButton addTargButton;
    private javax.swing.JMenuItem bannerProbeItem;
    private javax.swing.JMenuItem clearRepItem;
    private javax.swing.JMenuItem cmdProbeItem;
    private javax.swing.JMenuItem compileItem;
    public javax.swing.JDesktopPane deskPane;
    private javax.swing.JMenu editMenu;
    private javax.swing.JScrollPane exPane;
    private javax.swing.JSplitPane exSplit;
    private javax.swing.JTable exTable;
    private javax.swing.JMenuItem exitItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenuItem filePopItem;
    private javax.swing.JButton fireButton;
    private javax.swing.JMenu genMenu;
    private javax.swing.JButton helpButton;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JButton homeButton;
    private javax.swing.JInternalFrame homeFrame;
    private javax.swing.JMenuItem homeFrameItem;
    private javax.swing.JScrollPane homePane;
    private javax.swing.JSplitPane homeSplit;
    private javax.swing.JScrollPane homeTargPane;
    private javax.swing.JToolBar homeToolBar;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JButton loadConfigButton;
    private javax.swing.JMenu loadMenu;
    private javax.swing.JButton loadProbeButton;
    private javax.swing.JMenuItem loadProbeItem;
    private javax.swing.JMenuItem loadRepItem;
    private javax.swing.JMenuItem loadScanItem;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JButton minusTargButton;
    private javax.swing.JMenuItem namePopItem;
    private javax.swing.JTable optionTable;
    private javax.swing.JMenuItem oraProbeItem;
    private javax.swing.JButton probeButton;
    private javax.swing.JInternalFrame probeFrame;
    private javax.swing.JMenuItem probeFrameItem;
    private javax.swing.JToolBar probeToolBar;
    public javax.swing.JInternalFrame repFrame;
    private javax.swing.JMenuItem repFrameItem;
    private javax.swing.JButton repLoadButton;
    private javax.swing.JScrollPane repPane;
    private javax.swing.JButton repSaveButton;
    private javax.swing.JSplitPane repSplit;
    private javax.swing.JTable repTable;
    private javax.swing.JScrollPane repTargPane;
    private javax.swing.JTable repTargTable;
    private javax.swing.JTextArea repTextArea;
    private javax.swing.JToolBar repToolBar;
    private javax.swing.JScrollPane repTxtPane;
    private javax.swing.JButton reportButton;
    private javax.swing.JButton saveConfigButton;
    private javax.swing.JMenu saveMenu;
    private javax.swing.JMenuItem saveRepItem;
    private javax.swing.JMenuItem saveScanItem;
    private javax.swing.JButton scanButton;
    private javax.swing.JInternalFrame scanFrame;
    private javax.swing.JMenuItem scanFrameItem;
    private javax.swing.JScrollPane scanPane;
    private javax.swing.JTable scanTable;
    private javax.swing.JToolBar scanToolBar;
    private javax.swing.JSeparator sep1;
    private javax.swing.JMenuItem sqlProbeItem;
    private javax.swing.JButton stopButton;
    private javax.swing.JMenuItem submitProbeItem;
    private javax.swing.JTabbedPane tabPane;
    private javax.swing.JInternalFrame targFrame;
    private javax.swing.JTable targTable;
    private javax.swing.JPopupMenu targetPopup;
    private javax.swing.JToolBar toolBar;
    private javax.swing.JMenu toolsMenu;
    private javax.swing.JMenuItem updateAllItem;
    private javax.swing.JMenuItem updateConfItem;
    private javax.swing.JMenuItem updateInterItem;
    private javax.swing.JMenu updateMenu;
    private javax.swing.JMenuItem updateProbeItem;
    private javax.swing.JMenuItem verProbeItem;
    private javax.swing.JMenu windowMenu;
    // End of variables declaration//GEN-END:variables
    
    //ProbePanel probePanel, authProbePanel, infoProbePanel;
    //DatabaseProbePanel dbProbePanel;
    
    RepTableModel repTableModel;
    RepTargTableModel repTargTableModel;
    ScanTableModel scanTableModel;
    TargetTableModel targTableModel;
    GlobalOptionsTableModel gloptTableModel;
    ExTableModel exTableModel;
    
    JOptionPane jopt;
}
