/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * InfoProbePanel.java
 *
 * Created on May 7, 2003, 2:15 AM
 */

package com.securitycentric.metacoretex.gui;

import com.securitycentric.metacoretex.*;
import com.securitycentric.metacoretex.adapters.*;
import com.securitycentric.metacoretex.interfaces.*;
import com.securitycentric.metacoretex.lib.*;

import javax.swing.event.*;
import java.util.Vector;

/**
 *
 * @author  visigoth
 */
public class ProbePanel extends javax.swing.JPanel {
    
    /** Creates new form ProbePanel */
    public ProbePanel(Vector vect) {
        vector = vect;
        preInit();
        initComponents();
        postInit();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        enableBox = new javax.swing.JCheckBox();
        jSplitPane1 = new javax.swing.JSplitPane();
        topPane = new javax.swing.JScrollPane();
        probeTable = new javax.swing.JTable();
        botPane = new javax.swing.JScrollPane();
        optionTable = new javax.swing.JTable();

        setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.Y_AXIS));

        enableBox.setSelected(true);
        enableBox.setText("Enable Family");
        enableBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                enableBoxActionPerformed(evt);
            }
        });

        add(enableBox);

        jSplitPane1.setDividerLocation(200);
        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        probeTable.setModel(probTableModel);
        topPane.setViewportView(probeTable);

        jSplitPane1.setLeftComponent(topPane);

        optionTable.setModel(optTableModel);
        botPane.setViewportView(optionTable);

        jSplitPane1.setRightComponent(botPane);

        add(jSplitPane1);

    }//GEN-END:initComponents

    private void enableBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_enableBoxActionPerformed
        // Add your handling code here:
        ProbeToolz.setProbesEnabled(vector, enableBox.isSelected());
        probeTable.setEnabled(enableBox.isSelected());
        optionTable.setEnabled(enableBox.isSelected());
    }//GEN-LAST:event_enableBoxActionPerformed
        
    public void preInit() {
        optTableModel = new OptionsTableModel(vector);
        probTableModel = new ProbeTableModel(vector);
    }
    
    public void postInit() {
        optionTable.setDefaultEditor(String.class, new JTableStringEditor());
        
        probeTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent ev) {
                optTableModel.setIndex(probeTable.getSelectedRow());
                Init.selectedProbe = (Probe)vector.get(probeTable.getSelectedRow());
                optionTable.revalidate();
                optionTable.repaint();
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane botPane;
    private javax.swing.JCheckBox enableBox;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTable optionTable;
    private javax.swing.JTable probeTable;
    private javax.swing.JScrollPane topPane;
    // End of variables declaration//GEN-END:variables
    
    OptionsTableModel optTableModel;
    ProbeTableModel probTableModel;
    Vector vector;
    
}
