/*
 * SqlProbePanel.java
 *
 * Created on June 3, 2003, 10:10 PM
 */

package com.securitycentric.metacoretex.gui.wizards;

import com.securitycentric.metacoretex.lib.*;

import java.util.*;
import javax.swing.JFileChooser;

/**
 *
 * @author  visigoth
 */
public class OraclePlsqlPanel extends javax.swing.JPanel implements com.securitycentric.metacoretex.gui.wizards.ProbeTemplate {
    
    /** Creates new form SqlProbePanel */
    public OraclePlsqlPanel() {
        initComponents();
        setOpaque(true);
        setSize(500,400);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        fileButtonGroup = new javax.swing.ButtonGroup();
        centPanel = new javax.swing.JPanel();
        nameLabel = new javax.swing.JLabel();
        nameText = new javax.swing.JTextField();
        fileButton = new javax.swing.JRadioButton();
        fileLabel = new javax.swing.JLabel();
        fileText = new javax.swing.JTextField();
        browseButton = new javax.swing.JButton();
        editButton = new javax.swing.JRadioButton();
        txtPane = new javax.swing.JScrollPane();
        qryText = new javax.swing.JTextArea();

        setLayout(new java.awt.BorderLayout());

        centPanel.setLayout(new java.awt.GridBagLayout());

        nameLabel.setText("File Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.weighty = 1.0;
        centPanel.add(nameLabel, gridBagConstraints);

        nameText.setText("MyProbe.sql");
        nameText.setPreferredSize(new java.awt.Dimension(150, 25));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.weighty = 1.0;
        centPanel.add(nameText, gridBagConstraints);

        fileButton.setSelected(true);
        fileButton.setText("From Existing PL/SQL File");
        fileButtonGroup.add(fileButton);
        fileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weighty = 1.0;
        centPanel.add(fileButton, gridBagConstraints);

        fileLabel.setText("File");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.weighty = 1.0;
        centPanel.add(fileLabel, gridBagConstraints);

        fileText.setText("MyProbe.sql");
        fileText.setPreferredSize(new java.awt.Dimension(250, 25));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.weighty = 1.0;
        centPanel.add(fileText, gridBagConstraints);

        browseButton.setText("Browse...");
        browseButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.weighty = 1.0;
        centPanel.add(browseButton, gridBagConstraints);

        editButton.setText("Using Text Editor");
        fileButtonGroup.add(editButton);
        editButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weighty = 1.0;
        centPanel.add(editButton, gridBagConstraints);

        txtPane.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        txtPane.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        txtPane.setEnabled(false);
        qryText.setColumns(40);
        qryText.setRows(10);
        qryText.setTabSize(4);
        qryText.setEnabled(false);
        txtPane.setViewportView(qryText);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.weighty = 1.0;
        centPanel.add(txtPane, gridBagConstraints);

        add(centPanel, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents

    private void browseButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseButtonActionPerformed
        
        JFileChooser chooser = new JFileChooser(System.getProperty("user.dir"));
        chooser.setDialogTitle("Oracle PL/SQL File");
        int ret = chooser.showDialog(this,"Ok");
        if (ret == JFileChooser.APPROVE_OPTION) {
            fileText.setText(chooser.getSelectedFile().toString());
        }
    }//GEN-LAST:event_browseButtonActionPerformed

    private void editButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editButtonActionPerformed
        doEnable();
    }//GEN-LAST:event_editButtonActionPerformed

    private void fileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileButtonActionPerformed
        doEnable();
    }//GEN-LAST:event_fileButtonActionPerformed

    private void doEnable() {
        if (fileButton.isSelected()) {
            txtPane.setEnabled(false);
            qryText.setEnabled(false);
            fileText.setEnabled(true);
            browseButton.setEnabled(true);
        } else if (editButton.isSelected()) {
            txtPane.setEnabled(true);
            qryText.setEnabled(true);
            fileText.setEnabled(false);
            browseButton.setEnabled(false);
        }
        
    }
    public boolean checkProperties() {
        //FIXME
        return(true);
    }    
    
    public String getHelp() {
        return(help);
    }    
    
    public Properties getProperties() {
        Properties prop = new Properties();
        prop.setProperty("CONFIG_NAME",nameText.getText());
        
        if (fileButton.isSelected()) {
            prop.setProperty("CONFIG_FILE",fileText.getText());
        } else if (editButton.isSelected()) {
            prop.setProperty("CONFIG_VALUE",qryText.getText());
        }
        return(prop);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton fileButton;
    private javax.swing.JRadioButton editButton;
    private javax.swing.JTextField nameText;
    private javax.swing.JLabel nameLabel;
    private javax.swing.JLabel fileLabel;
    private javax.swing.JPanel centPanel;
    private javax.swing.JButton browseButton;
    private javax.swing.ButtonGroup fileButtonGroup;
    private javax.swing.JScrollPane txtPane;
    private javax.swing.JTextField fileText;
    private javax.swing.JTextArea qryText;
    // End of variables declaration//GEN-END:variables
    String help = "File Name - Name for file located in conf/\n"+
                  "File - Existing PL/SQL query file\n"+
                  "Using Text Editor- Write a PL/SQL query\n";
}
