/*
 * ProbeWizard.java
 *
 * Created on June 3, 2003, 11:47 AM
 */

package com.securitycentric.metacoretex.gui.wizards;

import com.securitycentric.metacoretex.*;
import com.securitycentric.metacoretex.lib.*;

import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.util.regex.*;

/**
 *
 * @author  visigoth
 */
public class ProbeWizard extends javax.swing.JFrame {
    
    /** Creates new form ProbeWizard */
    public ProbeWizard(File templateFile) {
        this.templateFile = templateFile;
        preInit();
        initComponents();
        postInit();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        buttonPanel = new javax.swing.JPanel();
        helpButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        backButton = new javax.swing.JButton();
        fwdButton = new javax.swing.JButton();
        finishButton = new javax.swing.JButton();
        layeredPane = new javax.swing.JLayeredPane();

        setTitle("Probe Wizard");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        helpButton.setText("Help");
        helpButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                helpButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(helpButton);

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(cancelButton);

        backButton.setText("Back");
        backButton.setPreferredSize(new java.awt.Dimension(75, 25));
        backButton.setEnabled(false);
        backButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                backButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(backButton);

        fwdButton.setText("Forward");
        fwdButton.setIconTextGap(0);
        fwdButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fwdButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(fwdButton);

        finishButton.setText("Finish");
        finishButton.setPreferredSize(new java.awt.Dimension(75, 25));
        finishButton.setEnabled(false);
        finishButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                finishButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(finishButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);

        getContentPane().add(layeredPane, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents
    
    private void helpButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpButtonActionPerformed
        //
        String help = ((ProbeTemplate)panVect.get(pageIndex)).getHelp();
        JOptionPane.showMessageDialog(this, help, "Help",JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_helpButtonActionPerformed
    
    private void finishButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_finishButtonActionPerformed
        // If the current panel douesn't pass, return
        if (!((ProbeTemplate)panVect.get(pageIndex)).checkProperties())
            return;
        
        fillProperties();
        Pattern pat = Pattern.compile("PROBE_[A-Z_]*");
        Pattern cpat = Pattern.compile("CONFIG_[A-Z_]*");
        String line;
        String newFileName = Init.config.get("probe.dir")+"/"+allProp.getProperty("PROBE_JAVA_NAME")+".java";
        
        try {
            
            /* If we have a config file to deal with, make it go!
             */
            if (allProp.containsKey("CONFIG_NAME")) {
                File confFile = new File(Init.config.get("conf.dir")+allProp.getProperty("CONFIG_NAME"));
                confFile.createNewFile();
                
                BufferedWriter cbw = new BufferedWriter(new FileWriter(confFile));
                
                if (allProp.containsKey("CONFIG_FILE")) {
                    String cfline = new String();
                    BufferedReader cbr = new BufferedReader(new FileReader(allProp.getProperty("CONFIG_FILE")));
                    
                    while ((cfline = cbr.readLine()) != null) {
                        cbw.write(cfline+"\n");
                    }
                    cbr.close();
                    
                } else if (allProp.containsKey("CONFIG_VALUE")) {
                    
                    cbw.write(allProp.getProperty("CONFIG_VALUE"));
                    
                }
                cbw.close();
            }
            
            
            BufferedReader br = new BufferedReader(new FileReader(templateFile));
            BufferedWriter bw = new BufferedWriter(new FileWriter(newFileName));
            
            while ((line = br.readLine()) != null) {
                
                line = propReplace(pat, line);
                line = propReplace(cpat, line);
                
                bw.write(line+"\n");
            }
            
            bw.close();
            br.close();
            
            setVisible(false);
            int reply = JOptionPane.showConfirmDialog(this, "Creation Successful!\nWould you like to compile your new probe?","Probe Generator",JOptionPane.YES_NO_OPTION);
            
            if (reply == JOptionPane.YES_OPTION)
                ProbeToolz.compileProbe(new File(newFileName));
            
        } catch (FileNotFoundException fe) {
            Init.doError("Probe Generator Error",fe);
        } catch (IOException ie) {
            Init.doError("Probe Generator Error", ie);
        }
        
        dispose();
    }//GEN-LAST:event_finishButtonActionPerformed
    
    private void backButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_backButtonActionPerformed
        //
        pageIndex--;
        layeredPane.moveToFront((Component)panVect.get(pageIndex));
        if (pageIndex == 0) {
            backButton.setEnabled(false);
        }
        fwdButton.setEnabled(true);
        finishButton.setEnabled(false);
    }//GEN-LAST:event_backButtonActionPerformed
    
    private void fwdButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fwdButtonActionPerformed
        // If the current panel douesn't pass, return
        if (!((ProbeTemplate)panVect.get(pageIndex)).checkProperties())
            return;
        
        pageIndex++;
        layeredPane.moveToFront((Component)panVect.get(pageIndex));
        if (pageIndex+1 >= panVect.size()) {
            fwdButton.setEnabled(false);
            finishButton.setEnabled(true);
        }
        backButton.setEnabled(true);
    }//GEN-LAST:event_fwdButtonActionPerformed
    
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        //
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        setVisible(false);
        dispose();
    }//GEN-LAST:event_exitForm
    
    public void preInit() {
        panVect = new Vector();
        allProp = new Properties();
    }
    
    public void postInit() {
        layeredPane.setPreferredSize(new Dimension(500,400));
        //layeredPane.setLayout(new BoxLayout(getContentPane(),BoxLayout.X_AXIS));
        pack();
        Init.centerWindow(this);
    }
    
    private String propReplace(Pattern ptrn, String str) {
        Matcher mat = ptrn.matcher(str);
        if (mat.find()) {
            
            String key = mat.group();
            
            if (allProp.containsKey(key)) {
                //System.out.println("Replacing Key: "+key+" with: " + allProp.getProperty(key));
                return(str.replaceAll(key,allProp.getProperty(key)));
            }
        }
        return(str);
    }
    
    public void addPanel(JPanel pan) {
        panVect.add(pan);
        layeredPane.add(pan, new Integer(10));
        layeredPane.validate();
    }
    
    private void fillProperties() {
        Iterator i = panVect.iterator();
        
        while (i.hasNext()) {
            ProbeTemplate tmp = (ProbeTemplate)i.next();
            Properties tmpPrp = tmp.getProperties();
            
            Enumeration e = tmpPrp.propertyNames();
            while (e.hasMoreElements()) {
                String key = (String)e.nextElement();
                String prop;
                
                if (key.startsWith("PROBE_"))
                    prop = tmpPrp.getProperty(key).replaceAll("\n",crazy);
                else
                    prop = tmpPrp.getProperty(key);
                
                allProp.setProperty(key,prop);
            }
        }
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLayeredPane layeredPane;
    private javax.swing.JButton backButton;
    private javax.swing.JButton finishButton;
    private javax.swing.JButton fwdButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton helpButton;
    // End of variables declaration//GEN-END:variables
    
    public Vector panVect; // Vector of the panels for this wizard.
    Properties allProp; // the big daddy of properties
    int pageIndex;
    File templateFile;
    String crazy = "\\\\\\\\n";
}
