/*
 * UpdateWizard.java
 *
 * Created on June 6, 2003, 7:39 PM
 */

package com.securitycentric.metacoretex.gui.wizards;

import com.securitycentric.metacoretex.*;
import com.securitycentric.metacoretex.lib.*;
import com.securitycentric.metacoretex.adapters.*;
import com.securitycentric.metacoretex.xml.update.*;

import java.util.*;
import javax.swing.JOptionPane;

/**
 *
 * @author  visigoth
 */
public class UpdateWizard extends javax.swing.JFrame implements Runnable {
    
    /** Creates new form UpdateWizard */
    public UpdateWizard() {
        initComponents();
        Init.centerWindow(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        centPanel = new javax.swing.JPanel();
        splitPane = new javax.swing.JSplitPane();
        probPane = new javax.swing.JScrollPane();
        probeTable = new javax.swing.JTable();
        confPane = new javax.swing.JScrollPane();
        confTable = new javax.swing.JTable();
        southPanel = new javax.swing.JPanel();
        cancelButton = new javax.swing.JButton();
        updateButton = new javax.swing.JButton();

        setTitle("MetaCoretex Update Interactive");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        centPanel.setLayout(new javax.swing.BoxLayout(centPanel, javax.swing.BoxLayout.Y_AXIS));

        splitPane.setDividerLocation(150);
        splitPane.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        probeTable.setPreferredScrollableViewportSize(new java.awt.Dimension(400, 150));
        probPane.setViewportView(probeTable);

        splitPane.setLeftComponent(probPane);

        confTable.setPreferredScrollableViewportSize(new java.awt.Dimension(400, 150));
        confPane.setViewportView(confTable);

        splitPane.setRightComponent(confPane);

        centPanel.add(splitPane);

        getContentPane().add(centPanel, java.awt.BorderLayout.CENTER);

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        southPanel.add(cancelButton);

        updateButton.setText("Update");
        updateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateButtonActionPerformed(evt);
            }
        });

        southPanel.add(updateButton);

        getContentPane().add(southPanel, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void updateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateButtonActionPerformed
        
        try {
            UpdateToolz.doUpdate(upDate);
        } catch (UpdateException e) {
            JOptionPane.showMessageDialog(this,e.getMessage(),"Update Failed!",JOptionPane.ERROR_MESSAGE);
        }
        setVisible(false);
        dispose();
    }//GEN-LAST:event_updateButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        
        setVisible(false);
        dispose();
        
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        setVisible(false);
        dispose();
    }//GEN-LAST:event_exitForm
    
    public void run() {
        try {
            upDate = UpdateToolz.getUpdate();
            UpdateToolz.removeDuplicates(upDate);
            probeTable.setModel(new UpdateTableModel(upDate, 1));
            confTable.setModel(new UpdateTableModel(upDate, 2));
            pack();
            show();
        } catch (UpdateException e) {
            JOptionPane.showMessageDialog(this,e.getMessage(), "Update Error!", JOptionPane.ERROR_MESSAGE);
            setVisible(false);
            dispose();
        }
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JPanel centPanel;
    private javax.swing.JScrollPane confPane;
    private javax.swing.JTable confTable;
    private javax.swing.JScrollPane probPane;
    private javax.swing.JTable probeTable;
    private javax.swing.JPanel southPanel;
    private javax.swing.JSplitPane splitPane;
    private javax.swing.JButton updateButton;
    // End of variables declaration//GEN-END:variables
    TreeMap newTree;
    TreeMap upTree;
    MCTXUpdate upDate;
    UpdateTableModel probeTabMod, confTabMod;
}
