/*
 * ProbeWizard.java
 *
 * Created on June 3, 2003, 11:47 AM
 */

package com.securitycentric.metacoretex.gui.wizards;

import com.securitycentric.metacoretex.*;
import com.securitycentric.metacoretex.lib.*;
import com.securitycentric.metacoretex.gui.*;
import com.securitycentric.metacoretex.xml.update.*;

import java.io.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.util.regex.*;

/**
 *
 * @author  visigoth
 */
public class UpdateWizard1 extends javax.swing.JFrame implements Runnable {
    
    /** Creates new form ProbeWizard */
    public UpdateWizard1() {
        preInit();
        initComponents();
        postInit();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        buttonPanel = new javax.swing.JPanel();
        helpButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        backButton = new javax.swing.JButton();
        nextButton = new javax.swing.JButton();
        updateButton = new javax.swing.JButton();
        layeredPane = new javax.swing.JLayeredPane();

        setTitle("Update Wizard");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        helpButton.setText("Help");
        helpButton.setMaximumSize(new java.awt.Dimension(75, 25));
        helpButton.setPreferredSize(new java.awt.Dimension(75, 25));
        helpButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                helpButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(helpButton);

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(cancelButton);

        backButton.setText("Back");
        backButton.setPreferredSize(new java.awt.Dimension(75, 25));
        backButton.setEnabled(false);
        backButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                backButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(backButton);

        nextButton.setText("Next");
        nextButton.setIconTextGap(0);
        nextButton.setPreferredSize(new java.awt.Dimension(75, 25));
        nextButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nextButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(nextButton);

        updateButton.setText("Update");
        updateButton.setPreferredSize(new java.awt.Dimension(80, 25));
        updateButton.setEnabled(false);
        updateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                updateButtonActionPerformed(evt);
            }
        });

        buttonPanel.add(updateButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.SOUTH);

        getContentPane().add(layeredPane, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents
    
    private void helpButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpButtonActionPerformed
        //
        JOptionPane.showMessageDialog(this, help, "Help",JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_helpButtonActionPerformed
    
    private void updateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateButtonActionPerformed
        int fileCount = 0;
        try {
            fileCount = UpdateToolz.doUpdate(upDate);
        } catch (UpdateException e) {
            Init.doError("Updater Error",e);
            return;
        }
        Init.doMessage("Update Complete", "Update Complete. "+
                                          fileCount+" files updated");
        setVisible(false);
        dispose();
    }//GEN-LAST:event_updateButtonActionPerformed
    
    private void backButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_backButtonActionPerformed
        //
        pageIndex--;
        layeredPane.moveToFront((Component)panVect.get(pageIndex));
        if (pageIndex == 0) {
            backButton.setEnabled(false);
        }
        nextButton.setEnabled(true);
        updateButton.setEnabled(false);
    }//GEN-LAST:event_backButtonActionPerformed
    
    private void nextButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextButtonActionPerformed
        
        pageIndex++;
        layeredPane.moveToFront((Component)panVect.get(pageIndex));
        if (pageIndex+1 >= panVect.size()) {
            nextButton.setEnabled(false);
            updateButton.setEnabled(true);
        }
        backButton.setEnabled(true);
    }//GEN-LAST:event_nextButtonActionPerformed
    
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        //
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        setVisible(false);
        dispose();
    }//GEN-LAST:event_exitForm
    
    public void preInit() {
        panVect = new Vector();
    }
    
    public void postInit() {
        layeredPane.setPreferredSize(new Dimension(500,400));
        pack();
        Init.centerWindow(this);
    }
    
    public void addPanel(JPanel pan) {
        panVect.add(pan);
        layeredPane.add(pan, new Integer(10));
        layeredPane.validate();
    }
    
    public void run() {
        UpdateStatus upStat = new UpdateStatus();
        Init.centerWindow(upStat);
        upStat.show();
        
        upStat.update("Getting Update XML Report", 30);
        
        try {
            upDate = UpdateToolz.getUpdate();
        } catch (UpdateException e) {
            Init.doError("Update Error while getting update XML", e);
            return;
        }
        
        upStat.update("Removing Current Entries", 50);
        UpdateToolz.removeDuplicates(upDate);
        
        upStat.update("Building Interactive Interface", 70);
        
        addPanel(new UpdatePanel(upDate, 1,"Select From Available Probe Updates"));
        addPanel(new UpdatePanel(upDate, 2,"Select From Available Config Updates"));
        addPanel(new UpdatePanel(upDate, 3,"Select From Available JAR Updates"));
        
        upStat.update("Complete",100);
        upStat.setVisible(false);
        upStat.dispose();
        
        show();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton backButton;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton cancelButton;
    private javax.swing.JButton helpButton;
    private javax.swing.JLayeredPane layeredPane;
    private javax.swing.JButton nextButton;
    private javax.swing.JButton updateButton;
    // End of variables declaration//GEN-END:variables
    
    public Vector panVect; // Vector of the panels for this wizard.
    MCTXUpdate upDate = null;
    private String help = "Use this wizard to select the updates you would like to install";
    int pageIndex;
}
