/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * AuthProbe.java
 *
 * Created on May 5, 2003, 7:17 AM
 */

package com.securitycentric.metacoretex.interfaces;

import com.securitycentric.metacoretex.lib.ProbeException;

/**
 *
 * @author  visigoth
 */
public interface AuthProbe extends Probe {
    
    public boolean isBrute();
    
    public void setBrute(boolean brute);
    
    /** The implementer of test is responsible for making sure that the
     *  resulting user/password success ends up in the report
     */
    public int test(String passwd) throws ProbeException;
    
    /** this is used as a runtime initializer on a per-probe basis.  Over-ride
     *  this method to give your probe a chance to initialize and check for
     *  necissary KB objects prior to the test() loop implemented by the probe()
     *  method in the AbstractAuthProbe.
     */
    public boolean shouldRun() throws ProbeException;
}
