/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * CommandProbe.java
 *
 * Created on May 4, 2003, 7:20 AM
 */

package com.securitycentric.metacoretex.interfaces;

import com.securitycentric.metacoretex.lib.ProbeException;

/**
 *
 * @author  visigoth
 */
public interface CommandProbe extends Probe {

    /** Set the command string used by the probe.
     *
     * @param String cmd should be just the executable name in path
     */
    public void setCommand(String cmd);

    /** Get the command string used by the probe
     *
     * @return String cmd 
     */
    public String getCommand();

    /** Set the arguements string to be used by the Probe.
     *
     * @param String args a string of the arguements
     */
    public void setArgs(String args);

    /** Get the arguement string used by the Probe.
     *
     * @return String args
     */
    public String getArgs();

    /** All tool stdout should be stored as a string in the following
     *  KB key.
     *
     * @param String key String for the KB key
     */
    public void setKbKey(String key);

    public String getKbKey();
}
