/*
 * ProbeClassLoader.java
 *
 * Created on June 18, 2003, 11:15 PM
 */

package com.securitycentric.metacoretex.lib;

import com.securitycentric.metacoretex.*;
import java.io.*;

/**
 *
 * @author  visigoth
 */
public class ProbeClassLoader extends java.lang.ClassLoader {
    
    /** Creates a new instance of ProbeClassLoader */
    public ProbeClassLoader(String dir) {
        this.dir = dir;
    }
    
    public ProbeClassLoader() {
        
    }
    
    public Class loadClass(String name) throws java.lang.ClassNotFoundException {
        
        /*
        Class c= findLoadedClass(name);
        if (c != null)
            return c;
         
        if (c == null) {
            byte[] data= lookupClassData(name);
            if (data == null)
                throw new ClassNotFoundException();
            c= defineClass(name, data, 0, data.length);
        }
        if (resolve)
            resolveClass(c);
        return c;
         */
        try {
            Class c= findSystemClass(name);
            return c;
        } catch (ClassNotFoundException e) {
            // keep searching
        }
        File fil = new File(dir+name+".class");
        
        if (! fil.exists())
            throw(new ClassNotFoundException(dir+name+".class not found"));
        
        byte[] data = getClassData(fil);
        
        if (data == null)
            throw(new ClassNotFoundException(dir+name+".class not found"));
        
        Class c = defineClass(name, data, 0, data.length);
        
        if (c == null)
            System.out.println("Failed to defineClass() from "+dir+name+".class");
        
        return(c);
    }
    
    public java.net.URL getResource(String name) {
        return ClassLoader.getSystemResource(name);
    }
    
    public java.io.InputStream getResourceAsStream(String name) {
        return ClassLoader.getSystemResourceAsStream(name);
    }
    
    private byte[] getClassData(File f) {
        try {
            FileInputStream stream= new FileInputStream(f);
            ByteArrayOutputStream out= new ByteArrayOutputStream(1000);
            byte[] b= new byte[1000];
            int n;
            
            while ((n= stream.read(b)) != -1)
                out.write(b, 0, n);
            
            stream.close();
            out.close();
            
            return(out.toByteArray());
            
        } catch (IOException e) {
        }
        return null;
    }
    
    String dir = System.getProperty("user.dir")+"/probes";
}
