/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * ProbeException.java
 *
 * Created on May 4, 2003, 8:12 AM
 */

package com.securitycentric.metacoretex.lib;

import java.util.*;

/**
 *
 * @author  visigoth
 */
public class ProbeException extends java.lang.Exception {
    
    /**
     * Creates a new instance of <code>ProbeException</code> without detail message.
     */
    public ProbeException() {
        probProp = new Properties();
    }
    
    
    /**
     * Constructs an instance of <code>ProbeException</code> with the specified detail message.
     * @param msg the detail message.
     */
    public ProbeException(String msg) {
        super(msg);
        probProp = new Properties();
    }
    
    public String getProbeName() {
        return(probeName);
    }
    
    public void setProbeName(String name) {
        probeName = name;
    }
    
    public Properties getProbeOptions() {
        return(probProp);
    }
    
    public void setProbeOptions(Properties prop) {
        probProp = prop;
    }
    
    private String probeName = "unknown";
    private Properties probProp;
}
