/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * ProbeReport.java
 *
 * Created on May 6, 2003, 9:59 PM
 */

package com.securitycentric.metacoretex.lib;

import com.securitycentric.metacoretex.*;
import java.util.*;

/**
 *
 * @author  visigoth
 */
public class ProbeReport {
    
    /** Creates a new instance of ProbeReport */
    public ProbeReport() {
        probeProp = new Properties();
    }
    
    public ProbeReport(int probeId) {
        this.probeId = probeId;
        probeName = ProbeToolz.getNameById(probeId);
        probeProp = new Properties();
    }
    
    public ProbeReport(int probeId, String report) {
        this.probeId = probeId;
        probeName = ProbeToolz.getNameById(probeId);
        probeReport = report;
        probeProp = new Properties();
    }
    
    public void setProbeId(int pid) {
        probeId = pid;
    }
    
    public int getProbeId() {
        return(probeId);
    }
    
    public String getProbeName() {
        return(probeName);
    }
    
    public void setProbeName(String name) {
        probeName = name;
    }
    
    public String getReport() {
        return(probeReport);
    }
    
    public void setReport(String rep) {
        probeReport = rep;
    }
    
    public int getSeverity() {
        return(severity);
    }
    
    public void setSeverity(int sev) {
        if (sev > 3)
            sev = 3;
        
        if (sev < 0)
            sev = 0;
        
        severity = sev;
    }
    
    public void setStart(long x) {
        start = x;
    }
    
    public void setStop(long x) {
        stop = x;
    }
    
    public long getStart() {
        return(start);
    }
    
    public long getStop() {
        return(stop);
    }
    
    public String getProbeVersion() {
        return(probeVersion);
    }
    
    public void setProbeVersion(String ver) {
        probeVersion = ver;
    }
    
    public void setProbeOptions(Properties prop) {
        probeProp = prop;
    }
    
    public Properties getProbeOptions() {
        return(probeProp);
    }
    
    private int probeId = 0;
    private int severity = 0;
    private long start, stop;
    private Properties probeProp;
    private String probeName = "No Probe Name";
    private String probeReport = "Empty Report";
    private String probeVersion = "no version";
    
}
