/*
 * ProbeSubmitter.java
 *
 * Created on June 22, 2003, 11:39 PM
 */

package com.securitycentric.metacoretex.lib;

import com.securitycentric.metacoretex.*;

import java.io.*;
import java.net.*;
import javax.net.ssl.*;
import javax.swing.JOptionPane;

/**
 *
 * @author  visigoth
 */
public class ProbeSubmitter implements java.lang.Runnable {
    
    /** Creates a new instance of ProbeSubmitter */
    public ProbeSubmitter(File prFile) {
        this.prFile = prFile;
    }
    
    public void run() {
        if (! prFile.getName().endsWith(".java")) {
            JOptionPane.showMessageDialog(null,prFile.getName()+" is not a JAVA source file!","Probe Submitter Error",JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        try {
            
            URL updateUrl = new URL((String)Init.config.get("update.url"));
            String sourceCode = new String();
            String line = new String();
            String response = new String();
            BufferedReader br = new BufferedReader(new FileReader(prFile));
            
            while ((line = br.readLine()) != null) {
                sourceCode = sourceCode.concat(line+"\n");
            }
            
            byte[] bytes = sourceCode.getBytes();
            
            HttpsURLConnection con = (HttpsURLConnection) updateUrl.openConnection();
            con.setDoOutput(true);
            con.setDoInput(true);
            con.setRequestMethod("POST");
            con.setRequestProperty("Content-length",String.valueOf(bytes.length));
            con.setRequestProperty("Probe-Name",prFile.getName());
            OutputStream out = con.getOutputStream();
            out.write(bytes);
            out.flush();
            
            BufferedReader in = new BufferedReader(
            new InputStreamReader(con.getInputStream()));
            
            while ((line = in.readLine()) != null) {
                response = response.concat(line+"\n");
            }
            
            in.close();
            out.close();
            con.disconnect();
            JOptionPane.showMessageDialog(null,response,"Probe Submission Success!",JOptionPane.INFORMATION_MESSAGE);
        
        
        } catch (MalformedURLException e) {
            JOptionPane.showMessageDialog(null,"URLException: "+e.getMessage(),"Probe Submitter Error",JOptionPane.ERROR_MESSAGE);
        } catch (IOException e) {
            JOptionPane.showMessageDialog(null,"IOException: "+e.getMessage(),"Probe Submitter Error",JOptionPane.ERROR_MESSAGE);
        }
        
        return;
    }
    
    File prFile;
}
