/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * ReportToolz.java
 *
 * Created on May 9, 2003, 9:26 AM
 */

package com.securitycentric.metacoretex.lib;

import com.securitycentric.metacoretex.*;
import com.securitycentric.metacoretex.xml.rep.*;

import javax.xml.bind.*;
import java.io.*;
import java.util.*;
import javax.swing.JOptionPane;

/**
 *
 * @author  visigoth
 */
public class ReportToolz {
    
    public static void SaveReport(File xmlRept) {
        try {
            xmlRept.createNewFile();
            JAXBContext jc = JAXBContext.newInstance("com.securitycentric.metacoretex.xml.rep");
            Marshaller m = jc.createMarshaller();
            m.setProperty("jaxb.formatted.output",new Boolean(true));
            ObjectFactory fact = new ObjectFactory();
            
            MCTXReport rept = fact.createScanReport();
            rept.setSaveDate(new GregorianCalendar());
            
            Iterator gloIt = Init.config.keySet().iterator();
            while (gloIt.hasNext()) {
                String key = (String)gloIt.next();
                MCTXOption opt = fact.createMCTXOption();
                opt.setName(key);
                opt.setValue((String)Init.config.get(key));
                
                rept.getGlobalOption().add(opt);
            }
            
            Iterator targIt = Init.reportVect.iterator();
            while (targIt.hasNext()) {
                Target targ = (Target)targIt.next();
                MCTXTarget mtarg = fact.createMCTXTarget();
                mtarg.setHost(targ.getHost());
                
                Iterator proIt = targ.getProbeReports().iterator();
                while (proIt.hasNext()) {
                    ProbeReport probRept = (ProbeReport)proIt.next();
                    MCTXProbeReport mtxProbRept = fact.createMCTXProbeReport();
                    
                    mtxProbRept.setProbeId(probRept.getProbeId());
                    mtxProbRept.setProbeName(probRept.getProbeName());
                    mtxProbRept.setSeverity(probRept.getSeverity());
                    mtxProbRept.setProbeVersion(probRept.getProbeVersion());
                    mtxProbRept.setProbeStart(probRept.getStart());
                    mtxProbRept.setProbeStop(probRept.getStop());
                    mtxProbRept.setReport(probRept.getReport());
                    
                    Properties probProp = probRept.getProbeOptions();
                    Iterator propIter = probProp.keySet().iterator();
                    while (propIter.hasNext()) {
                        String key = (String)propIter.next();
                        String val = probProp.getProperty(key);
                        MCTXOption mctxOpt = fact.createMCTXOption();
                        mctxOpt.setName(key);
                        mctxOpt.setValue(val);
                        mtxProbRept.getProbeOption().add(mctxOpt);
                    }
                    
                    mtarg.getProbeReport().add(mtxProbRept);
                }
                Iterator exIt = targ.getProbeExceptions().iterator();
                while (exIt.hasNext()) {
                    ProbeException pe = (ProbeException)exIt.next();
                    MCTXProbeException mtxPe = fact.createMCTXProbeException();
                    mtxPe.setProbeName(pe.getProbeName());
                    mtxPe.setException(pe.getMessage());
                    
                    Properties probProp = pe.getProbeOptions();
                    Iterator propIter = probProp.keySet().iterator();
                    while (propIter.hasNext()) {
                        String key = (String)propIter.next();
                        String val = probProp.getProperty(key);
                        MCTXOption mctxOpt = fact.createMCTXOption();
                        mctxOpt.setName(key);
                        mctxOpt.setValue(val);
                        mtxPe.getProbeOption().add(mctxOpt);
                    }
                    
                    mtarg.getProbeException().add(mtxPe);
                }
                
                rept.getTarget().add(mtarg);
            }
            
            OutputStream os = new FileOutputStream(xmlRept);
            m.marshal( rept, os );
            
        } catch (JAXBException je) {
            JOptionPane.showMessageDialog(null,je.getMessage(),"Save Failed!",JOptionPane.ERROR_MESSAGE);
            je.printStackTrace();
        } catch (FileNotFoundException fe) {
            JOptionPane.showMessageDialog(null,fe.getMessage(),"Save Failed!",JOptionPane.ERROR_MESSAGE);
            fe.printStackTrace();
        } catch (IOException ie) {
            JOptionPane.showMessageDialog(null,ie.getMessage(),"Save Failed!",JOptionPane.ERROR_MESSAGE);
            ie.printStackTrace();
        }
    }
    
    public static void LoadReport(File xmlRept) {
        
        Init.clearProbeReports();
        
        try {
            JAXBContext jc = JAXBContext.newInstance("com.securitycentric.metacoretex.xml.rep");
            Unmarshaller um = jc.createUnmarshaller();
            MCTXReport rept = (MCTXReport)um.unmarshal(xmlRept);
            
            Iterator xOptIter = rept.getGlobalOption().iterator();
            while (xOptIter.hasNext()) {
                //wanna load options from report into something?
                xOptIter.next();
            }
            
            Iterator xTargIter = rept.getTarget().iterator();
            while (xTargIter.hasNext()) {
                MCTXTarget xTarg = (MCTXTarget)xTargIter.next();
                Target tmpTarg = new Target(xTarg.getHost());
                
                Iterator xRepIter = xTarg.getProbeReport().iterator();
                while(xRepIter.hasNext()) {
                    MCTXProbeReport xRept = (MCTXProbeReport)xRepIter.next();
                    ProbeReport tmpRept = new ProbeReport(xRept.getProbeId());
                    tmpRept.setProbeName(xRept.getProbeName());
                    tmpRept.setSeverity(xRept.getSeverity());
                    tmpRept.setProbeVersion(xRept.getProbeVersion());
                    tmpRept.setStart(xRept.getProbeStart());
                    tmpRept.setStop(xRept.getProbeStop());
                    tmpRept.setReport(xRept.getReport());
                    
                    tmpTarg.addProbeReport(tmpRept);
                }
                
                Iterator xExIter = xTarg.getProbeException().iterator();
                while (xExIter.hasNext()) {
                    MCTXProbeException xEx = (MCTXProbeException)xExIter.next();
                    ProbeException tmpEx = new ProbeException(xEx.getException());
                    tmpEx.setProbeName(xEx.getProbeName());
                    
                    tmpTarg.addProbeException(tmpEx);
                }
                Init.reportVect.add(tmpTarg);
            }
        
        } catch (JAXBException je) {
            JOptionPane.showMessageDialog(null,je.getMessage(),"Load Failed!",JOptionPane.ERROR_MESSAGE);
            je.printStackTrace();
        }
    }
    
}
