/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * TLock.java
 *
 * $Id: TLock.java,v 1.2 2003/05/25 21:49:13 visigoth_6 Exp $
 *
 * This class contains the syncronized functions to
 * lock, and unlock Targets
 */


package com.securitycentric.metacoretex.lib;

import com.securitycentric.metacoretex.*;

import java.util.*;

public class TLock {
    
    public static synchronized Target lockTarget() {
        
        Iterator i = Init.targVect.iterator();
        
        while( i.hasNext() ) {
            Target targ = (Target)i.next();
            
            if ( ! targ.isLocked() ) {
                targ.setLocked(true);
                return(targ);
            }
        }
        
        // By this point, we are probably done
        
        return(null);
        
    }
    
    public static synchronized void unlockTarget(Target targ) {
        
        targ.setLocked(false);
    }
    
    public static synchronized void unlockAll() {
        
        Iterator i = Init.targVect.iterator();
        
        while( i.hasNext() ) {
            Target targ = (Target)i.next();
            targ.setLocked(false);
        }
    }
}
