/*
 *(c) 2003, visigoth <visigoth@securitycentric.com>
 * This source code is distributed under a BSD license,
 * please see the LICENSE file for details
 *
 * Target.java
 *
 * Created on May 4, 2003, 11:45 AM
 * 
 */

package com.securitycentric.metacoretex.lib;

import java.util.*;


/** 
 *
 * @author  visigoth
 */
public class Target {
    
    /** Creates a new instance of the KnowlegeBase
     */
    public Target(String host) {
        this.host = host;
        kb = new Hashtable();
        exVect = new Vector();
        repVect = new Vector();
    }

    public String getHost() {
        return(host);
    }
    
    public void setHost(String name) {
        host = name;
    }

    public boolean isLocked() {
        return(locked);
    }

    public void setLocked(boolean bol) {
        locked = bol;
    }
    
    public void kbPut(String key, Object val) {
        kb.put(key,val);
    }
    
    public Object kbGet(String key) {
        return(kb.get(key));
    }
    
    public boolean kbHas(String key) {
        return(kb.containsKey(key));
    }
    
    public void addProbeReport(ProbeReport prpt) {
        repVect.add(prpt);
    }
    
    public Vector getProbeReports() {
        return(repVect);
    }
    
    public void clearProbeReports() {
        repVect.clear();
    }
    
    public void addProbeException(ProbeException pe) {
        exVect.add(pe);
    }
    
    public Vector getProbeExceptions() {
        return(exVect);
    }
    
    public void clearProbeExceptions() {
        exVect.clear();
    }
    
    public void clearKb() {
        kb.clear();
    }
    
    public int getSeverityCount(int sev) {
        int count = 0;
        Iterator i = repVect.iterator();
        while (i.hasNext()) {
            ProbeReport repTmp = (ProbeReport)i.next();
            if (repTmp.getSeverity() == sev)
                count++;
        }
        return(count);
    }

    // The host name/IP
    private String host;
    // A knowlege-base for just this targ
    public Hashtable kb;
    // A vector of thrown ProbeExceptions for this target
    public Vector exVect;
    // A vector of ProbeReport(s)
    public Vector repVect;
    // A boolean for threads to know whose next
    private boolean locked = false;
}
